Given three numbers n, r and p, compute value of ^{n}C_{r} mod p.

Examples:

Input: n = 10, r = 2, p = 13 Output: 6 Explanation:^{10}C_{2}is 45 and 45 % 13 is 6. Input: n = 1000, r = 900, p = 13 Output: 8

We strongly recommend to refer below post as a prerequisite of this.

Compute ^{n}C_{r} % p | Set 1 (Introduction and Dynamic Programming Solution)

We have introduced overflow problem and discussed Dynamic Programming based solution in above set 1. The time complexity of the DP based solution is O(n*r) and it required O(n) space. The time taken and extra space become very high for large values of n, especially values close to 10^{9}.

In this post, Lucas Theorem based solution is discussed. Time complexity of this solution is O(p^{2} * Log_{p} n) and it requires only O(p) space.

**Lucas Theorem:**

For non negative integers n and r and a prime p, the following congruence relation holds:

where

and

**Using Lucas Theorem for ^{n}C_{r} % p:**

*Lucas theorem basically suggests that the value of*.

^{n}C_{r}can be computed by multiplying results of^{ni}C_{ri}where n_{i}and r_{i}are individual same-positioned digits in base p representations of n and r respectively.The idea is to one by one compute ^{ni}C_{ri} for individual digits n_{i} and r_{i} in base p. We can compute these values DP based solution discussed in previous post. Since these digits are in base p, we would never need more than O(p) space and time complexity of these individual computations would be bounded by O(p^{2}).

Below is C++ implementation of above idea

// A Lucas Theorem based solution to compute nCr % p #include<bits/stdc++.h> using namespace std; // Returns nCr % p. In this Lucas Theorem based program, // this function is only called for n < p and r < p. int nCrModpDP(int n, int r, int p) { // The array C is going to store last row of // pascal triangle at the end. And last entry // of last row is nCr int C[r+1]; memset(C, 0, sizeof(C)); C[0] = 1; // Top row of Pascal Triangle // One by constructs remaining rows of Pascal // Triangle from top to bottom for (int i = 1; i <= n; i++) { // Fill entries of current row using previous // row values for (int j = min(i, r); j > 0; j--) // nCj = (n-1)Cj + (n-1)C(j-1); C[j] = (C[j] + C[j-1])%p; } return C[r]; } // Lucas Theorem based function that returns nCr % p // This function works like decimal to binary conversion // recursive function. First we compute last digits of // n and r in base p, then recur for remaining digits int nCrModpLucas(int n, int r, int p) { // Base case if (r==0) return 1; // Compute last digits of n and r in base p int ni = n%p, ri = r%p; // Compute result for last digits computed above, and // for remaining digits. Multiply the two results and // compute the result of multiplication in modulo p. return (nCrModpLucas(n/p, r/p, p) * // Last digits of n and r nCrModpDP(ni, ri, p)) % p; // Remaining digits } // Driver program int main() { int n = 1000, r = 900, p = 13; cout << "Value of nCr % p is " << nCrModpLucas(n, r, p); return 0; }

Output:

Value of nCr % p is 8

**Time Complexity:** Time complexity of this solution is O(p^{2} * Log_{p} n). There are O(Log_{p} n) digits in base p representation of n. Each of these digits is smaller than p, therefore, computations for individual digits take O(p^{2}). Note that these computations are done using DP method which takes O(n*r) time.

**Alternate Implementation with O(p ^{2} + Log_{p} n) time and O(p^{2}) space:**

The idea is to precompute Pascal triangle for size p x p and store it in 2D array. All values needed would now take O(1) time. Therefore overall time complexity becomes O(p

^{2}+ Log

_{p}n).

This article is contributed by **Ruchir Garg**. Please write comments if you find anything incorrect, or you want to share more information about the topic discussed above